/**
 * Program RobominShutdownHook.java
 * 
 * Date         Version    Author         Comment
 * 2008/03/17   1.0.0      T.Kawashima    First.
 * 
 */

package robomin;

import java.io.FileOutputStream;
import java.io.IOException;
import java.util.concurrent.CopyOnWriteArrayList;

import robomin.robot.RobotInfo;
import robomin.util.RobominDef;
import robomin.util.RobominInfo;
import robomin.util.RobominProperties;

/**
 * Vbg_EtbN
 * @author T.Kawashima
 * @version 1.0.0
 */
public class RobominShutdownHook extends Thread {
	private RobominInfo info;
	private RobominProperties prop;
	
	/**
	 * RXgN^
	 * @param info RobominInfo
	 */
	public RobominShutdownHook(RobominInfo info) {
		this.info = info;
		this.prop = info.getRobominProperties();
	}
	
	/**
	 * Threadprun\bh
	 */
	public void run() {
		CopyOnWriteArrayList<RobotInfo> rInfoList = info.getRobotInfoList();
		
		// \Pbǧ㏈yRobotInfo̕ۑ
		if (rInfoList != null) {
			// ݒ̈ɓo^ς݃{bgۑ
			for (int i=0; i<rInfoList.size(); i++) {
				RobotInfo rInfo = rInfoList.get(i);
				
				// ڑ̃{bg͐ؒf
				if (!rInfo.isClosed()) {
					rInfo.disconnectRobot();
					System.out.println("Socket closed: " + rInfo.getName() + " (" + rInfo.getAddr() + ")");
				}
				
				prop.setProperty(RobominDef.PROPKEY_NTADDR_BASE + i, rInfo.getAddr());
				prop.setProperty(RobominDef.PROPKEY_NTNAME_BASE + i, rInfo.getName());
			}
			
			// o^̗͖̈Iɏ
			for (int i=rInfoList.size(); i<RobominDef.PROPNTNUM_MAX; i++) {
				prop.setProperty(RobominDef.PROPKEY_NTADDR_BASE + i, "");
				prop.setProperty(RobominDef.PROPKEY_NTNAME_BASE + i, "");
			}
		}
		
		// ݒۑ
		prop.setPropertyInt(RobominDef.PROPKEY_LANGUAGE, info.getLanguage());
		
		// Oxۑ
		prop.setPropertyInt(RobominDef.PROPKEY_LOGLEVEL, info.getRobominLogger().getLogLevel());
		
		// vpeBt@Cւ̕ۑ
		try {
			prop.store(new FileOutputStream(RobominDef.PROPFILE_NAME), RobominDef.PROPFILE_NAME);
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}
}
