/**
 * Program Roboministrator.java
 * 
 * Date         Version    Author         Comment
 * 2008/03/19   1.0.0      T.Kawashima    First.
 * 
 */

package robomin;

import java.util.logging.Level;

import robomin.robot.NetTansorCmd;
import robomin.robot.RobotInfo;
import robomin.ui.RobominGUI;
import robomin.util.RobominLogger;
import robomin.util.RobominDef;
import robomin.util.RobominInfo;
import robomin.util.RobominProperties;

/**
 * Roboministrator̃CNX
 * @author T.Kawashima
 * @version 1.0.0
 */
public class Roboministrator {
	/**
	 * C\bh
	 * @param args Ox(0vI 1dv 2 3fobO)
	 */
	public static void main(String[] args) {
		// ʏۑCX^X𐶐
		RobominInfo info = new RobominInfo();
		
		// vpeBǗCX^X𐶐
		final RobominProperties prop = new RobominProperties(RobominDef.PROPFILE_NAME);
		info.setRobominProperties(prop);
		
		// Vbg_EtbNo^
		Runtime.getRuntime().addShutdownHook(new RobominShutdownHook(info));
		
		// K[𐶐
		RobominLogger logger = new RobominLogger(info);
		
		// Ox̐ݒ
		int level = RobominDef.LOGLEVEL_DEFUALT;
		
		try {
			level = Integer.parseInt(args[0]);
			
			if (level < RobominDef.LOGLEVEL_SEVERE || level > RobominDef.LOGLEVEL_DEBUG) {
				level = RobominDef.LOGLEVEL_DEFUALT;
			}
		}
		catch (ArrayIndexOutOfBoundsException e) {
			int propLevel = prop.getPropertyInt(RobominDef.PROPKEY_LOGLEVEL);
			
			if (propLevel != -1) {
				level = propLevel;
			}
			else {
				level = RobominDef.LOGLEVEL_DEFUALT;
				prop.setPropertyInt(RobominDef.PROPKEY_LOGLEVEL, level);
			}
		}
		
		logger.setLogLevel(level);
		info.setRobominLogger(logger);
		
		// \̐ݒ
		int language = prop.getPropertyInt(RobominDef.PROPKEY_LANGUAGE);
		
		if (language == -1) {
			language = RobominDef.LANG_DEFUALT;
			prop.setPropertyInt(RobominDef.PROPKEY_LANGUAGE, language);
		}
		
		info.setLanguage(language);
		
		// GUI𐶐
		RobominGUI ui = new RobominGUI(RobominDef.APPLI_NAME + " " + RobominDef.VERSION, info);
		info.setRobominGUI(ui);
		
		logger.log(Level.SEVERE, "----- Log level " + level + " -----");
		logger.log(Level.CONFIG, "RobominGUI instantiated");
		
		// ݒ肩o^ς݃lbg^T[̃AhXƖOǂݍ
		for (int i=0; i<RobominDef.PROPNTNUM_MAX; i++) {
			String ipAddress = prop.getProperty(RobominDef.PROPKEY_NTADDR_BASE + i);
			String name = prop.getProperty(RobominDef.PROPKEY_NTNAME_BASE + i);
			
			// IPAhXÔǂ炩݂Ȃꍇ͍킹ď
			if (ipAddress == null || name == null) {
				logger.log(Level.WARNING, "Init " + RobominDef.PROPKEY_NTADDR_BASE + i);
				logger.log(Level.WARNING, "Init " + RobominDef.PROPKEY_NTNAME_BASE + i);
				prop.setProperty(RobominDef.PROPKEY_NTADDR_BASE + i, "");
				prop.setProperty(RobominDef.PROPKEY_NTNAME_BASE + i, "");
			}
			
			if (ipAddress != null && name != null){
				// LȒlꍇ͓o^
				if (!ipAddress.equals("") && !name.equals("")) {
					ui.addRobotInfo(new RobotInfo(info, name, ipAddress));
					logger.log(Level.INFO, "Add " + name + " (" + ipAddress + ")");
				}
				// LȒlȂꍇ͈ȍ~o^Ȃ
				// ܂o^ς݃AhX1珇ɋLڂĂ̂Ƃ
				else {
					logger.log(Level.CONFIG, "Registering Robot (" + info.getRegisteredRobotNum() + ") completed.");
					break;
				}
			}
		}
		
		// lbg^T[CX^X𐶐
		NetTansorCmd tNet = new NetTansorCmd(info);
		info.setNetTansorCmd(tNet);
		logger.log(Level.CONFIG, "NetTansorCmd instantiated");
		
		// SWTp[v
		ui.guiThreadLoop();
	}
}
