/**
 * Program ConsoleTab.java
 * 
 * Date         Version    Author         Comment
 * 2008/03/12   1.0.0      T.Kawashima    First.
 * 
 */

package robomin.ui;

import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.SWT;
import org.eclipse.swt.SWTException;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;

import robomin.util.RobominInfo;

/**
 * R\[^u
 * @author T.Kawashima
 * @version 1.0.0
 */
public class ConsoleTab {
	private Image tabIcon;
	private CTabItem consoleTabItem;
	private Text consoleText;
	private int language;
	
	public ConsoleTab(CTabFolder tabFolder, RobominInfo info) {
		language = info.getLanguage();
		ImageRegistry imgReg = new ImageRegistry();
		
		try {
			tabIcon = new Image(Display.getDefault(), GUIDef.TABFOLDER_ICONPATH);
			imgReg.put(GUIDef.APPLICATION_ICONPATH, tabIcon);
		}
		catch (SWTException e) {
			//logger.log(Level.SEVERE, "G[", e);
		}
		
		consoleTabItem = new CTabItem(tabFolder, SWT.NONE);
		consoleTabItem.setText(GUIDef.TABFOLDER_CONSOLE[language]);
		consoleTabItem.setImage(tabIcon);
		
		consoleText = new Text(tabFolder, SWT.MULTI | SWT.BORDER | SWT.V_SCROLL);
		consoleTabItem.setControl(consoleText);
	}
	
	/**
	 * R\[ɃOǋL
	 * @param msg ǋL郍O
	 */
	public void addConsoleText(final String msg) {
		if (Display.getDefault() == null) return;
		
		Display.getDefault().asyncExec(new Runnable() {
			public void run() {
				if (consoleText != null)
					consoleText.append(msg + "\n");
			}
		});
	}
}
