/**
 * Program RobominInfo.java
 * 
 * Date         Version    Author         Comment
 * 2008/03/19   1.0.0      T.Kawashima    First.
 * 
 */

package robomin.util;

import java.util.concurrent.CopyOnWriteArrayList;
import java.util.logging.Level;

import robomin.robot.NetTansorCmd;
import robomin.robot.RobotInfo;
import robomin.sensor.PhidgetIKP;
import robomin.ui.RobominGUI;

/**
 * RoboministratoȑۑNX
 * @author T.Kawashima
 * @version 1.0.0
 */
public class RobominInfo {
	private NetTansorCmd tNet = null;
	private PhidgetIKP pSensor = null;
	private RobominGUI ui = null;
	private RobominLogger logger = null;
	private RobominProperties prop = null;
	private int language = -1;
	private CopyOnWriteArrayList<RobotInfo> robotList;
	
	/**
	 * RXgN^
	 */
	public RobominInfo() {
		robotList = new CopyOnWriteArrayList<RobotInfo>();
	}
	
	/**
	 * RobotInfoListԂ
	 * @return RobotInfoList
	 */
	public CopyOnWriteArrayList<RobotInfo> getRobotInfoList() {
		return this.robotList;
	}
	
	/**
	 * RobotInfoǉ
	 * @param rInfo ǉRobotInfo
	 * @return TRUEAsFALSE
	 */
	public boolean addRobotInfo(RobotInfo rInfo) {
		if (robotList.size() < RobominDef.PROPNTNUM_MAX) {
			return robotList.add(rInfo);
		}
		
		return false;
	}
	
	/**
	 * RobotInfoԂ
	 * @param index ԂRobotInfoCfbNX
	 * @return RobotInfo
	 */
	public RobotInfo getRobotInfo(int index) {
		return robotList.get(index);
	}
	
	/**
	 * w肳ꂽOIPAhXƈvRobotInfoԂ
	 * @param name O
	 * @param ipAddr IPAhX
	 * @return RobotInfo
	 */
	public RobotInfo getRobotInfo(String name, String ipAddr) {
		// vRobotInfo擾
		for (int i=0; i<robotList.size(); i++) {
			RobotInfo rInfo = this.getRobotInfo(i);
			if (rInfo.getName().equals(name) && rInfo.getAddr().equals(ipAddr)) {
				return rInfo;
			}
		}
		
		return null;
	}
	
	/**
	 * RobotInfo폜
	 * @param rInfo 폜RobotInfo
	 * @return 폜RobotInfõCfbNX
	 */
	public int removeRobotInfo(RobotInfo rInfo) {
		for (int i=0; i<robotList.size(); i++) {
			RobotInfo rInfoTemp = this.getRobotInfo(i);
			if (rInfoTemp.getName().equals(rInfo.getName()) && rInfo.getAddr().equals(rInfo.getAddr())) {
				robotList.remove(i);
				logger.log(Level.INFO, "Remove (" + i + ") " + rInfo.getName() + " (" + rInfo.getAddr() + ")");
				return i;
			}
		}
		
		return RobominDef.FAIL;
	}
	
	/**
	 * o^ςRobotInfo̐Ԃ
	 * @return RobotInfo̓o^
	 */
	public int getRegisteredRobotNum() {
		return this.robotList.size();
	}
	
	/**
	 * \ݒ肷
	 * @param language \錾 LANG_JPALANG_EN
	 */
	public void setLanguage(int language) {
		if (RobominDef.LANG_JP <= language || RobominDef.LANG_EN >= language) {
			this.language = language;
		}
		else {
			this.language = RobominDef.LANG_DEFUALT;
		}
	}
	
	/**
	 * ݒ肳Ă錾ݒl擾
	 * @return ݒl
	 */
	public int getLanguage() {
		return this.language;
	}
	
	/**
	 * RobominPropertiesZbg
	 * @param prop ZbgRobominProperties
	 */
	public void setRobominProperties(RobominProperties prop) {
		this.prop = prop;
	}
	
	/**
	 * ZbgςRobominPropertiesԂ
	 * @return ZbgςRobominProperties
	 */
	public RobominProperties getRobominProperties() {
		return this.prop;
	}
	
	/**
	 * RobominLoggerZbg
	 * @param logger ZbgRobominLogger
	 */
	public void setRobominLogger(RobominLogger logger) {
		this.logger = logger;
	}
	
	/**
	 * ZbgςRobominLoggerԂ
	 * @return ZbgςRobominLogger
	 */
	public RobominLogger getRobominLogger() {
		return this.logger;
	}
	
	/**
	 * TansorClientGUIZbg
	 * @param ui TansorClientGUI
	 */
	public void setRobominGUI(RobominGUI ui) {
		this.ui = ui;
	}
	
	/**
	 * TansorClientGUIԂ
	 * @return ZbgςTansorClientGUI
	 */
	public RobominGUI getRobominGUI() {
		return this.ui;
	}
	
	/**
	 * NetTansorCmdZbg
	 * @param tNet NetTansorCmd
	 */
	public void setNetTansorCmd(NetTansorCmd tNet) {
		this.tNet = tNet;
	}
	
	/**
	 * ZbgςNetTansorCmdԂ
	 * @return NetTansorCmd
	 */
	public NetTansorCmd getNetTansorCmd() {
		return this.tNet;
	}
	
	/**
	 * PhidgetSensorZbg
	 * @param pSensor PhidgetSensor
	 */
	public void setPhidgetSensor(PhidgetIKP pSensor) {
		this.pSensor = pSensor;
	}
	
	/**
	 * ZbgςPhidgetSensorԂ
	 * @return PhidgetSensor
	 */
	public PhidgetIKP getPhidgetSensor() {
		return this.pSensor;
	}
}
