/**
 * Program RobominLogger.java
 * 
 * Date         Version    Author         Comment
 * 2008/03/17   1.0.0      T.Kawashima    First.
 * 
 */

package robomin.util;

import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;

/**
 * RoboministratorpK[
 * @author T.Kawashima
 * @version 1.0.0
 */
public class RobominLogger {
	private RobominInfo info;
	private Logger logger;
	private Level level;
	private int logLevel;
	private DateFormat dataFormat;
	
	/**
	 * RXgN^
	 * @param info RobominInfo
	 */
	public RobominLogger(RobominInfo info) {
		this.info = info;
		try {
			// K[쐬
			logger = Logger.getLogger(RobominDef.APPLI_NAME, null);
			FileHandler fileHandler = new FileHandler(RobominDef.LOGFILE_NAME, true);
			fileHandler.setFormatter(new SimpleFormatter());
	        logger.addHandler(fileHandler);
	        dataFormat = new SimpleDateFormat("HH:mm:ss");
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * ݒ肳Ă郍OxԂ
	 * @return Ox
	 */
	public int getLogLevel() {
		return this.logLevel;
	}
	
	/**
	 * \郍Õxݒ肷
	 * @param logLevel ݒ肷郍Ox
	 */
	public void setLogLevel(int logLevel) {
		this.logLevel = logLevel;
		
        switch (logLevel) {
        case RobominDef.LOGLEVEL_SEVERE:
        	logger.setLevel(Level.SEVERE);
        	level = Level.SEVERE;
        	break;
        case RobominDef.LOGLEVEL_WARNING:
        	logger.setLevel(Level.WARNING);
        	level = Level.WARNING;
        	break;
        case RobominDef.LOGLEVEL_INFO:
        	logger.setLevel(Level.INFO);
        	level = Level.INFO;
        	break;
        case RobominDef.LOGLEVEL_DEBUG:
        	logger.setLevel(Level.CONFIG);
        	level = Level.CONFIG;
        	break;
        default:
        	logger.setLevel(Level.INFO);
        	level = Level.INFO;
        	this.logLevel = RobominDef.LOGLEVEL_INFO;
        	break;
        }
	}
	
	/**
	 * t@CƃR\[ɃOLڂ
	 * @param level Ox
	 * @param msg O
	 */
	public void log(Level level, String msg) {
		logger.log(level, msg);
		
		if (this.level.intValue() <= level.intValue()) {
			Date date = new Date();
	        String log = dataFormat.format(date) + " " + msg;
	        
	        if (info.getRobominGUI() != null) {
	        	info.getRobominGUI().consoleTab.addConsoleText(log);
	        }
		}
	}
	
	/**
	 * t@CƃR\[ɃO(O)Lڂ
	 * @param level Ox
	 * @param msg ^Cg
	 * @param thrown O
	 */
	public void log(Level level, String msg, Exception thrown) {
		logger.log(level, msg, thrown);
		
		if (this.level.intValue() <= level.intValue()) {
	        Date date = new Date();
			String log = dataFormat.format(date) + " " + msg + thrown.toString();
			
			if (info.getRobominGUI() != null) {
				info.getRobominGUI().consoleTab.addConsoleText(log);
				info.getRobominGUI().consoleTab.addConsoleText(thrown.toString());
			}
		}
	}
}
